#include "exactSol.h"


exactSol::exactSol(){
}

void exactSol::initialize(int nMeshes,
			  real t,
			  int ** pointNumberMeshU, 
			  real ***xU, 
			  int ** pointNumberMeshV, 
			  real ***xV, 
			  int ** pointNumberMeshW, 
			  real ***xW, 
			  int ** pointNumberMeshP, 
			  real ***xP, 
			  real ****exactU, 
			  real ****exactV,
			  real ****exactW,
			  real ****exactP){

  //wavenumebr in x and y directions
  // must be consistent to that in flowSolver.cpp
  nx = 1;
  ny = 1;
  nz = 1;


  for (m=0; m<nMeshes; m++) {
    for (k=0; k<pointNumberMeshU[m][2]; k++) {
      for (j=0; j<pointNumberMeshU[m][1]; j++) {
	for (i=0; i<pointNumberMeshU[m][0]; i++) {
	  exactU[m][i][j][k] = 0.0;
	  
	  /*
	  exactU[m][i][j][k] = 
	    sin( xU[m][0][i] )
	    * cos( xU[m][1][j] ) 
	    * cos( xU[m][2][k] ) 
	    * exp(-3.0 * t);
	    */

	}
      }
    }
  }

  for (m=0; m<nMeshes; m++) {
    for (k=0; k<pointNumberMeshV[m][2]; k++) {
      for (j=0; j<pointNumberMeshV[m][1]; j++) {
	for (i=0; i<pointNumberMeshV[m][0]; i++) {
	  exactV[m][i][j][k] = 0.0;

	  /*
	  exactV[m][i][j][k] = 
	    cos( xV[m][0][i] )
	    * sin( xV[m][1][j] ) 
	    * cos( xV[m][2][k] ) 
	    * exp(-3.0 * t);
	    */
	}
      }
    }
  }

  for (m=0; m<nMeshes; m++) {
    for (k=0; k<pointNumberMeshW[m][2]; k++) {
      for (j=0; j<pointNumberMeshW[m][1]; j++) {
	for (i=0; i<pointNumberMeshW[m][0]; i++) {
	  exactW[m][i][j][k] = 0.0;

	  /*
	  exactW[m][i][j][k] = 
	    -2.0 * cos( xW[m][0][i] )
	    * cos( xW[m][1][j] ) 
	    * sin( xW[m][2][k] ) 
	    * exp(-3.0 * t);
	    */
	}
      }
    }
  }

  for (m=0; m<nMeshes; m++) {
    for (k=0; k<pointNumberMeshP[m][2]; k++) {
      for (j=0; j<pointNumberMeshP[m][1]; j++) {
	for (i=0; i<pointNumberMeshP[m][0]; i++) {
	  exactP[m][i][j][k] = 0.0;

	  /*
	  exactP[m][i][j][k] =
	    ( cos(2.0 * xP[m][0][i])
	      * cos(2.0 * xP[m][1][j])
	      + ( cos(2.0 * xP[m][0][i]) + cos(2.0 *xP[m][1][j]) )
	      * ( -cos(2.0 * xP[m][2][k]) + 1.0) / 2.0
	      - cos(2.0 * xP[m][2][k]) )
	    * exp(-6.0 * t) / 4.0;
	    */
	}
      }
    }
  }


}


exactSol::~exactSol(){
}
