#ifndef INPUTDATA_H
#define INPUTDATA_H

/** \file inputData.cpp
    \brief read input file with a free format.

    This class make it easy to read an input file with a free format. In the input file, the variable can be put anywhere and their meaningful comments are very useful for users.

*/

#include "calc.hh" 
using namespace calc_load;

#include <fstream>
#include <sstream>
#include <iostream>
#include <string>
#include <stdlib.h>
using namespace std;



#ifdef SINGLE
#define real float
#else
#define real double
#endif

/** 
    \brief read input file with a free format.

    This class make it easy to read an input file with a free format. In the input file, the variable can be put anywhere and their meaningful comments are very useful for users.

*/
class inputData {

 public:
  /**
     constructor
   */
  inputData();

/** 
    \brief read a real vvariable.

    \param s a string of the variable name
    \param sValue the assigned real value of the variable
*/  
  void read(string s, real &sValue);

/** 
    \brief read an integer variable.

    \param s a string of the variable name
    \param sValue the assigned integer value of the variable
*/ 
  void read(string s, int &sValue);

  /**
     destructor
   */
  ~inputData();
  
 private: 
  
  string filename;
  
  Calculator<double> ee ;

  bool ok;
  
};

#endif
