c******************************************************
      subroutine strf(a,n,pvt,info)
      implicit real*8 (a-h,o-z)
      integer pvt(*)
      call sgetrf(n,n,a,n,pvt,info)
      return
      end
c******************************************************
      subroutine strs(a,n,b,m,ipiv,info)
      call sgetrs('N',n,m,a,n,ipiv,b,n,info)
      return
      end
c******************************************************
      subroutine dtrf(a,n,pvt,info)
      implicit real*8 (a-h,o-z)
      integer pvt(*)
      call dgetrf(n,n,a,n,pvt,info)
      return
      end
c******************************************************
      subroutine dtrs(a,n,b,m,pvt,info)
      implicit real*8 (a-h,o-z)
      integer pvt(*)
      call dgetrs('N',n,m,a,n,pvt,b,n,info)
      return
      end
c******************************************************
      subroutine ssvd(a,u,v,m,n,s,wk,lwk,i)
      call sgesvd('A','A',m,n,a,m,s,u,m,v,n,wk,lwk,i)
      return
      end
c******************************************************
      subroutine dsvd(a,u,v,m,n,s,wk,lwk,i)
      implicit real*8 (a-h,o-z)
      call dgesvd('A','A',m,n,a,m,s,u,m,v,n,wk,lwk,i)
      return
      end
c******************************************************
      subroutine origainv(u,w,v,m,n,a,b,c)
      real*4 w(*)
      real*4 u(m,*),v(n,*),a(m,*),b(m,*),c(n,*)


      do i=1,m
         do j=1,m
            b(i,j)=0.0
            do k=1,n
               b(i,j)=b(i,j)+u(i,k)*u(j,k)
            enddo
c            write(6,*) 'u * ut',i,j,c(i,j),b(i,j)
         enddo
      enddo
      return

c     c=a inv = v (1/w) ut
      do i=1,n
         do j=1,m
            c(i,j)=0.0
            do k=1,n
               c(i,j)=c(i,j)+v(k,i)*(1/w(k))*u(j,k)
            enddo
         enddo
      enddo
c     b = a c = a a inv
      do i=1,m
         do j=1,m
            b(i,j)=0.0
            do k=1,n
               b(i,j)=b(i,j)+a(i,k)*c(k,j)
            enddo
         enddo
      enddo


c      do i=1,n
c         do j=1,n
c            c(i,j)=0.0
c            do k=1,m
c               c(i,j)=c(i,j)+u(k,i)*u(k,j)
c            enddo
c            write(6,*) 'ut * u',i,j,c(i,j)
c         enddo
c      enddo
      return
      end
c******************************************************
c******************************************************
      subroutine suut(u,m,n,b)
      real*4 u(m,*),b(m,*)
      do i=1,m
         do j=1,m
            b(i,j)=0.0
            do k=1,n
               b(i,j)=b(i,j)+u(i,k)*u(j,k)
            enddo
         enddo
      enddo
      return
      end
c******************************************************
      subroutine duut(u,m,n,b)
      real*8 u(m,*),b(m,*)
      do i=1,m
         do j=1,m
            b(i,j)=0.0
            do k=1,n
               b(i,j)=b(i,j)+u(i,k)*u(j,k)
            enddo
         enddo
      enddo
      return
      end
c******************************************************
      subroutine ssol(u,w,v,m,n,b,x,t)
      real*4 w(*)
      real*4 u(m,*),v(n,*),b(*),x(*),t(*),s
c  Qianlong changed it to 
c      real maxValue
c
c      maxValue = 0.0;
c      do j=1,n
c         if( abs( w(j) ) > maxValue ) then
c            maxValue = abs( w(j) )
c         endif
c      end do
c  Qianlong changed it to 

      do j=1,n
         s=0
c         if(abs(w(j)).ne.0.0)then
c  Qianlong changed it to 
c         if(abs(w(j)) > maxValue * 1.e-3)then
         if(abs(w(j)) > 1.e-14)then
            do i=1,m
               s=s+u(i,j)*b(i)
            end do
            s=s/w(j)
         endif
         t(j)=s
      end do
      do j=1,n
         s=0
         do i=1,n
            s=s+v(i,j)*t(i)
         end do
         x(j)=s
      end do
      return
      end
c******************************************************
      subroutine dsol(u,w,v,m,n,b,x,t)
      real*8 w(*)
      real*8 u(m,*),v(n,*),b(*),x(*),t(*),s

c  Qianlong changed it to 
c      real maxValue
c
c      maxValue = 0.0;
c     do j=1,n
c         if( abs( w(j) ) > maxValue ) then
c            maxValue = abs( w(j) )
c         endif
c      end do
c  Qianlong changed it to 

      do j=1,n
         s=0
c        if(abs(w(j)).ne.0.0)then
c  Qianlong changed it to 
         
c         if(abs(w(j)) > maxValue * 1.e-3)then
         if(abs(w(j)) > 1.e-14)then
            do i=1,m
               s=s+u(i,j)*b(i)
            end do
            s=s/w(j)
         endif
         t(j)=s
      end do
      do j=1,n
         s=0
         do i=1,n
            s=s+v(i,j)*t(i)
         end do
         x(j)=s
      end do
      return
      end
c******************************************************
      subroutine zsol(u,w,v,m,n,b,x,t)
      real*8 w(*)
      complex*16 u(m,*),v(n,*),b(*),x(*),t(*),s
      do j=1,n
         s=0
         if(abs(w(j)).ne.0.0)then
            do i=1,m
               s=s+conjg(u(i,j))*b(i)
            end do
            s=s/w(j)
         endif
         t(j)=s
      end do
      do j=1,n
         s=0
         do i=1,n
            s=s+conjg(v(i,j))*t(i)
         end do
         x(j)=s
      end do
      return
      end
c******************************************************
      subroutine cpass1(u,b,w,m,s)
      real*8 w
      complex*16 u(*),b(*),s
      s=0
      do i=1,m
         s=s+conjg(u(i))*b(i)
      end do
      s=s/w
      return
      end
c******************************************************
      subroutine cpass2(v,t,n,s)
      complex*16 v(*),t(*),s
      s=0
      do i=1,n
         s=s+conjg(v(i))*t(i)
      end do
      return
      end
c******************************************************
      subroutine dcginv(u,w,v,m,n,l,a,lda,b,c)
      real*8 w(*)
      real*8 u(m,*),v(n,*),a(lda,*),b(l,*),c(n,*)
c     c=g inv = v (1/w) ut
      do i=1,n
         do j=1,m
            c(i,j)=0.0
            do k=1,n
               c(i,j)=c(i,j)+v(k,i)*(1/w(k))*u(j,k)
            enddo
         enddo
      enddo
c     b = a c = a g inv
      do i=1,l
         do j=1,m
            b(i,j)=0.0
            do k=1,n
               b(i,j)=b(i,j)+a(i,k)*c(k,j)
            enddo
         enddo
      enddo

      return
      end
      subroutine scginv(u,w,v,m,n,l,a,lda,b,c)
      real*4 w(*)
      real*4 u(m,*),v(n,*),a(lda,*),b(l,*),c(n,*)
c     c=g inv = v (1/w) ut
      do i=1,n
         do j=1,m
            c(i,j)=0.0
            do k=1,n
               c(i,j)=c(i,j)+v(k,i)*(1/w(k))*u(j,k)
            enddo
         enddo
      enddo
c     b = a c = a g inv
      do i=1,l
         do j=1,m
            b(i,j)=0.0
            do k=1,n
               b(i,j)=b(i,j)+a(i,k)*c(k,j)
            enddo
         enddo
      enddo

      return
      end
