/** \mainpage PHYSALIS

    \section intro_sec Introduction

    The finite-difference PHYSALIS method can be used to perform direct numerical simulations of fluid-partilces interactions in complex geometry. Noteworthy features of the method are:
    - The no-slip condition at the particle surface is satisfied exactly.
    - The lower-order underdetermined coefficients give the force, torque, and stresslet on the sphere directly, thus avoiding the need to integrate the calculated fluid stress over the particle surface.
    - If the Stokes approximation is used beyond its approximate domain of validity, the iterative process will not converge. In this sense, the method contains a built-in accuracy test.

    The current solver has been implemented using a locally refined mesh for the spheres in the PHYSALIS method.

    \section install_sec Installation

    Download the <a href="./sourceCode.tar">tar file</a> and uncompress it.

    \section runCode_sec Run the code

    First run the command <b>make main</b>. Then, run the command <b>./main</b>

    \section setCode_sec Set the initial and boundary conditions

    The initial conditions for three velocity components can be set in the file initCond.cpp. The boundary conditions for three velocity components can be set in the file boundaryCond.cpp. They may be Dirichlet, Neumann, periodic, or other boundary conditions. 

    \author Qianlong Liu <Qianlong.Liu@jhu.edu>\n
    Advisor: Prof. Prosperetti prosperetti@jhu.edu

    \date April 2008 - March 2009

    \version 1.0

 */

