#include "outputData.h"


outputData::outputData(){
}

void outputData::initialize(int tStep, // time step
			    int NumberOfMeshes,
			    int cellNumberPerPatch,
			    int ** StartIndex, 
			    int ** pointNumberMeshU, 
			    int ** pointNumberMeshV, 
			    int ** pointNumberMeshW, 
			    int ** pointNumberMeshP, 
			    real ***xU, 
			    real ***xV, 
			    real ***xW, 
			    real ***xP, 
			    real ****u, 
			    real ****v,
			    real ****w,
			    real ****p){


  outputU(tStep,
	  NumberOfMeshes,
	  cellNumberPerPatch,
	  StartIndex,
	  pointNumberMeshU,
	  pointNumberMeshP,
	  xU,
	  xP,
	  u);
  
  outputV(tStep,
	  NumberOfMeshes,
	  cellNumberPerPatch,
	  StartIndex,
	  pointNumberMeshV,
	  pointNumberMeshP,
	  xV,
	  xP,
	  v);
  outputW(tStep,
	  NumberOfMeshes,
	  cellNumberPerPatch,
	  StartIndex,
	  pointNumberMeshW,
	  pointNumberMeshP,
	  xW,
	  xP,
	  w);

  outputP(tStep,NumberOfMeshes,cellNumberPerPatch,StartIndex,pointNumberMeshP,xP,p);
  
  
}

void outputData::outputU(int tStep,
			 int NumberOfMeshes,
			 int cellNumberPerPatch,
			 int ** StartIndex, 
			 int ** pointNumberMeshU, 
			 int ** pointNumberMeshP, 
			 real ***xU, 
			 real ***xP, 
			 real ****u){

  real ****uOutput;
  
  uOutput = allocate4dRealArrayOutput(NumberOfMeshes, pointNumberMeshP);

  // only need m=0
  m=0;

  for (kCenter=0; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=0; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=0; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2;
	k = kCenter / 2;

	coarseToCenter(1, 0, 0, u, uOutput);
      }
    }
  }
    
  for (kCenter=0; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=0; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=1; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2;
	k = kCenter / 2;

	coarseToCenter(0, 0, 0, u, uOutput);
      }
    }
  }

  for (kCenter=0; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=1; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=0; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2 + 1;
	k = kCenter / 2;

	coarseToCenter(1, 1, 0, u, uOutput);
      }
    }
  }

  for (kCenter=1; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=0; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=0; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2;
	k = kCenter / 2 + 1;

	coarseToCenter(1, 0, 1, u, uOutput);
      }
    }
  }

  for (kCenter=0; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=1; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=1; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2 + 1;
	k = kCenter / 2;

	coarseToCenter(0, 1, 0, u, uOutput);
      }
    }
  }

  for (kCenter=1; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=0; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=1; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2;
	k = kCenter / 2 + 1;

	coarseToCenter(0, 0, 1, u, uOutput);
      }
    }
  }

  for (kCenter=1; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=1; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=0; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2 + 1;
	k = kCenter / 2 + 1;

	coarseToCenter(1, 1, 1, u, uOutput);
      }
    }
  }

  for (kCenter=1; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=1; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=1; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2 + 1;
	k = kCenter / 2 + 1;

	coarseToCenter(0, 1, 1, u, uOutput);
      }
    }
  }
  

  for (m=1; m<NumberOfMeshes; m++) {
    for (k=0; k<=pointNumberMeshP[m][2]-1; k=k+1) {
      for (j=0; j<=pointNumberMeshP[m][1]-1; j=j+1) {
	for (i=0; i<=pointNumberMeshP[m][0]-1; i=i+1) {

	  iCenter = 2 * (StartIndex[m][0] - 1) + i;
	  jCenter = 2 * (StartIndex[m][1] - 1) + j;
	  kCenter = 2 * (StartIndex[m][2] - 1) + k;

	  uOutput[0][iCenter][jCenter][kCenter] =
	    ( u[m][i][j][k] + u[m][i+1][j][k] ) / 2.0;
	}
      }
    }
  }


  filenameU = "results/u" + iToString(tStep) + ".dat";
  
  ofU.open( filenameU.c_str() ) ;
  
  ofU<< 2 * pointNumberMeshP[0][0] <<endl; // # in x direction
  ofU<< 2 * pointNumberMeshP[0][1] <<endl; // # in y direction
  ofU<< 2 * pointNumberMeshP[0][2] <<endl; // # in z direction

  //x coordinate
  for (i=0; i<=pointNumberMeshP[0][0]-1; i=i+1) {
    ofU<< xP[0][0][i] - (xP[0][0][1] - xP[0][0][0]) / 4.0 <<endl;
    ofU<< xP[0][0][i] + (xP[0][0][1] - xP[0][0][0]) / 4.0 <<endl;
  }

  //y coordinate
  for (j=0; j<=pointNumberMeshP[0][1]-1; j=j+1) {
    ofU<< xP[0][1][j] - (xP[0][1][1] - xP[0][1][0]) / 4.0 <<endl;
    ofU<< xP[0][1][j] + (xP[0][1][1] - xP[0][1][0]) / 4.0 <<endl;
  }

  //z coordinate
  for (k=0; k<=pointNumberMeshP[0][2]-1; k=k+1) {
    ofU<< xP[0][2][k] - (xP[0][2][1] - xP[0][2][0]) / 4.0 <<endl;
    ofU<< xP[0][2][k] + (xP[0][2][1] - xP[0][2][0]) / 4.0 <<endl;
  }


  //  k = pointNumberMeshP[0][2]; 
 
  // store first row j=0, next second row j=1, ans so on
  for (k=0; k<= 2 * pointNumberMeshP[0][2]-1; k=k+1) {
    for (j=0; j<= 2 * pointNumberMeshP[0][1]-1; j=j+1) {
      for (i=0; i<= 2 * pointNumberMeshP[0][0]-1; i=i+1) {
	//middle surface
	ofU<< uOutput[0][i][j][k] <<endl;
      }
    }
  }  

  /*   Vapor
  ofU.open(filenameU.c_str(), ios_base::out | ios_base::binary) ;

  real temp;

  temp = 2 * pointNumberMeshP[0][0]; // # in x direction
  ofU.write((char *) &temp, sizeof(real));

  temp = 2 * pointNumberMeshP[0][1]; // # in y direction
  ofU.write((char *) &temp, sizeof(real));
  
  //x coordinate
  for (i=0; i<=pointNumberMeshP[0][0]-1; i=i+1) {

    temp = xP[0][0][i] - (xP[0][0][1] - xP[0][0][0]) / 4.0; // # in x direction
    ofU.write((char *) &temp, sizeof(real));
    
    temp = xP[0][0][i] + (xP[0][0][1] - xP[0][0][0]) / 4.0; // # in y direction
    ofU.write((char *) &temp, sizeof(real));

  }

  //y coordinate
  for (j=0; j<=pointNumberMeshP[0][1]-1; j=j+1) {

    temp = xP[0][1][j] - (xP[0][1][1] - xP[0][1][0]) / 4.0; // # in x direction
    ofU.write((char *) &temp, sizeof(real));
    
    temp = xP[0][1][j] + (xP[0][1][1] - xP[0][1][0]) / 4.0; // # in y direction
    ofU.write((char *) &temp, sizeof(real));

  }

  k = pointNumberMeshP[0][2]; 
 
  // store first row j=0, next second row j=1, ans so on
  for (j=0; j<= 2 * pointNumberMeshP[0][1]-1; j=j+1) {
    for (i=0; i<= 2 * pointNumberMeshP[0][0]-1; i=i+1) {
      //middle surface

      temp = uOutput[0][i][j][k]; // # in x direction
      ofU.write((char *) &temp, sizeof(real));

    }
  }
  */
  
  ofU.close();

  delete4dArrayOutput(uOutput, NumberOfMeshes, pointNumberMeshP);

}



void outputData::outputV(int tStep,
			 int NumberOfMeshes,
			 int cellNumberPerPatch,
			 int ** StartIndex, 
			 int ** pointNumberMeshV, 
			 int ** pointNumberMeshP, 
			 real ***xV, 
			 real ***xP, 
			 real ****v){

  real ****vOutput;
  
  vOutput = allocate4dRealArrayOutput(NumberOfMeshes, pointNumberMeshP);

  // only need m=0
  m=0;

  for (kCenter=0; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=0; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=0; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2;
	k = kCenter / 2;

	coarseToCenter(0, 1, 0, v, vOutput);
      }
    }
  }
    
  for (kCenter=0; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=1; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=0; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2;
	k = kCenter / 2;

	coarseToCenter(0, 0, 0, v, vOutput);
      }
    }
  }

  for (kCenter=0; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=0; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=1; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2 + 1;
	j = jCenter / 2;
	k = kCenter / 2;

	coarseToCenter(1, 1, 0, v, vOutput);
      }
    }
  }

  for (kCenter=1; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=0; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=0; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2;
	k = kCenter / 2 + 1;

	coarseToCenter(0, 1, 1, v, vOutput);
      }
    }
  }

  for (kCenter=0; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=1; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=1; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2 + 1;
	j = jCenter / 2;
	k = kCenter / 2;

	coarseToCenter(1, 0, 0, v, vOutput);
      }
    }
  }

  for (kCenter=1; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=1; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=0; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2;
	k = kCenter / 2 + 1;

	coarseToCenter(0, 0, 1, v, vOutput);
      }
    }
  }

  for (kCenter=1; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=0; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=1; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2 + 1;
	j = jCenter / 2;
	k = kCenter / 2 + 1;

	coarseToCenter(1, 1, 1, v, vOutput);
      }
    }
  }

  for (kCenter=1; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=1; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=1; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2 + 1;
	j = jCenter / 2;
	k = kCenter / 2 + 1;

	coarseToCenter(1, 0, 1, v, vOutput);
      }
    }
  }
  

  for (m=1; m<NumberOfMeshes; m++) {
    for (k=0; k<=pointNumberMeshP[m][2]-1; k=k+1) {
      for (j=0; j<=pointNumberMeshP[m][1]-1; j=j+1) {
	for (i=0; i<=pointNumberMeshP[m][0]-1; i=i+1) {

	  iCenter = 2 * (StartIndex[m][0] - 1) + i;
	  jCenter = 2 * (StartIndex[m][1] - 1) + j;
	  kCenter = 2 * (StartIndex[m][2] - 1) + k;

	  vOutput[0][iCenter][jCenter][kCenter] =
	    ( v[m][i][j][k] + v[m][i][j+1][k] ) / 2.0;
	}
      }
    }
  }


  filenameV = "results/v" + iToString(tStep) + ".dat";

  /*
  ofV.open( filenameV.c_str(), ios_base::out | ios_base::binary ) ;
  
  real temp;

  temp = 2 * pointNumberMeshP[0][0]; // # in x direction
  ofV.write((char *) &temp, sizeof(real));

  temp = 2 * pointNumberMeshP[0][1]; // # in y direction
  ofV.write((char *) &temp, sizeof(real));
  
  //x coordinate
  for (i=0; i<=pointNumberMeshP[0][0]-1; i=i+1) {

    temp = xP[0][0][i] - (xP[0][0][1] - xP[0][0][0]) / 4.0; // # in x direction
    ofV.write((char *) &temp, sizeof(real));
    
    temp = xP[0][0][i] + (xP[0][0][1] - xP[0][0][0]) / 4.0; // # in y direction
    ofV.write((char *) &temp, sizeof(real));

  }

  //y coordinate
  for (j=0; j<=pointNumberMeshP[0][1]-1; j=j+1) {

    temp = xP[0][1][j] - (xP[0][1][1] - xP[0][1][0]) / 4.0; // # in x direction
    ofV.write((char *) &temp, sizeof(real));
    
    temp = xP[0][1][j] + (xP[0][1][1] - xP[0][1][0]) / 4.0; // # in y direction
    ofV.write((char *) &temp, sizeof(real));

  }

  k = pointNumberMeshP[0][2]; 
 
  // store first row j=0, next second row j=1, ans so on
  for (j=0; j<= 2 * pointNumberMeshP[0][1]-1; j=j+1) {
    for (i=0; i<= 2 * pointNumberMeshP[0][0]-1; i=i+1) {
      //middle surface
      temp = vOutput[0][i][j][k]; // # in x direction
      ofV.write((char *) &temp, sizeof(real));
    }
  }
  */

  
  ofV.open( filenameV.c_str() ) ;
  
  ofV<< 2 * pointNumberMeshP[0][0] <<endl; // # in x direction
  ofV<< 2 * pointNumberMeshP[0][1] <<endl; // # in y direction
  ofV<< 2 * pointNumberMeshP[0][2] <<endl; // # in z direction

  //x coordinate
  for (i=0; i<=pointNumberMeshP[0][0]-1; i=i+1) {
    ofV<< xP[0][0][i] - (xP[0][0][1] - xP[0][0][0]) / 4.0 <<endl;
    ofV<< xP[0][0][i] + (xP[0][0][1] - xP[0][0][0]) / 4.0 <<endl;
  }

  //y coordinate
  for (j=0; j<=pointNumberMeshP[0][1]-1; j=j+1) {
    ofV<< xP[0][1][j] - (xP[0][1][1] - xP[0][1][0]) / 4.0 <<endl;
    ofV<< xP[0][1][j] + (xP[0][1][1] - xP[0][1][0]) / 4.0 <<endl;
  }

  //z coordinate
  for (k=0; k<=pointNumberMeshP[0][2]-1; k=k+1) {
    ofV<< xP[0][2][k] - (xP[0][2][1] - xP[0][2][0]) / 4.0 <<endl;
    ofV<< xP[0][2][k] + (xP[0][2][1] - xP[0][2][0]) / 4.0 <<endl;
  }

  //  k = pointNumberMeshP[0][2]; 
 
  // store first row j=0, next second row j=1, ans so on
  for (k=0; k<= 2 * pointNumberMeshP[0][2]-1; k=k+1) {
    for (j=0; j<= 2 * pointNumberMeshP[0][1]-1; j=j+1) {
      for (i=0; i<= 2 * pointNumberMeshP[0][0]-1; i=i+1) {
	//middle surface
	ofV<< vOutput[0][i][j][k] <<endl;
      }
    }
  }
  
  ofV.close();

  delete4dArrayOutput(vOutput, NumberOfMeshes, pointNumberMeshP);

}

void outputData::outputW(int tStep,
			 int NumberOfMeshes,
			 int cellNumberPerPatch,
			 int ** StartIndex, 
			 int ** pointNumberMeshW, 
			 int ** pointNumberMeshP, 
			 real ***xW, 
			 real ***xP, 
			 real ****w){

  real ****wOutput;
  
  wOutput = allocate4dRealArrayOutput(NumberOfMeshes, pointNumberMeshP);

  // only need m=0
  m=0;

  for (kCenter=0; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=0; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=0; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2;
	k = kCenter / 2;

	coarseToCenter(0, 0, 1, w, wOutput);
      }
    }
  }
    
  for (kCenter=1; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=0; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=0; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2;
	k = kCenter / 2;

	coarseToCenter(0, 0, 0, w, wOutput);
      }
    }
  }

  for (kCenter=0; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=1; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=0; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2 + 1;
	k = kCenter / 2;

	coarseToCenter(0, 1, 1, w, wOutput);
      }
    }
  }

  for (kCenter=0; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=0; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=1; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2 + 1;
	j = jCenter / 2;
	k = kCenter / 2;

	coarseToCenter(1, 0, 1, w, wOutput);
      }
    }
  }

  for (kCenter=1; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=1; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=0; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2;
	j = jCenter / 2 + 1;
	k = kCenter / 2;

	coarseToCenter(0, 1, 0, w, wOutput);
      }
    }
  }

  for (kCenter=1; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=0; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=1; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2 + 1;
	j = jCenter / 2;
	k = kCenter / 2;

	coarseToCenter(1, 0, 0, w, wOutput);
      }
    }
  }

  for (kCenter=0; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=1; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=1; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2 + 1;
	j = jCenter / 2 + 1;
	k = kCenter / 2;

	coarseToCenter(1, 1, 1, w, wOutput);
      }
    }
  }

  for (kCenter=1; kCenter<=2 * pointNumberMeshP[m][2]-1; kCenter=kCenter+2) {
    for (jCenter=1; jCenter<=2 * pointNumberMeshP[m][1]-1; jCenter=jCenter+2) {
      for (iCenter=1; iCenter<=2 * pointNumberMeshP[m][0]-1; iCenter=iCenter+2) {
	i = iCenter / 2 + 1;
	j = jCenter / 2 + 1;
	k = kCenter / 2;

	coarseToCenter(1, 1, 0, w, wOutput);
      }
    }
  }
  

  for (m=1; m<NumberOfMeshes; m++) {
    for (k=0; k<=pointNumberMeshP[m][2]-1; k=k+1) {
      for (j=0; j<=pointNumberMeshP[m][1]-1; j=j+1) {
	for (i=0; i<=pointNumberMeshP[m][0]-1; i=i+1) {

	  iCenter = 2 * (StartIndex[m][0] - 1) + i;
	  jCenter = 2 * (StartIndex[m][1] - 1) + j;
	  kCenter = 2 * (StartIndex[m][2] - 1) + k;

	  wOutput[0][iCenter][jCenter][kCenter] =
	    ( w[m][i][j][k] + w[m][i][j][k+1] ) / 2.0;
	}
      }
    }
  }


  filenameW = "results/w" + iToString(tStep) + ".dat";

  /*
  ofW.open( filenameW.c_str(), ios_base::out | ios_base::binary ) ;

  real temp;

  temp = 2 * pointNumberMeshP[0][0]; // # in x direction
  ofW.write((char *) &temp, sizeof(real));
  
  temp = 2 * pointNumberMeshP[0][1]; // # in y direction
  ofW.write((char *) &temp, sizeof(real));

  //x coordinate
  for (i=0; i<=pointNumberMeshP[0][0]-1; i=i+1) {

    temp = xP[0][0][i] - (xP[0][0][1] - xP[0][0][0]) / 4.0; // # in x direction
    ofW.write((char *) &temp, sizeof(real));
    
    temp = xP[0][0][i] + (xP[0][0][1] - xP[0][0][0]) / 4.0; // # in y direction
    ofW.write((char *) &temp, sizeof(real));

  }

  //y coordinate
  for (j=0; j<=pointNumberMeshP[0][1]-1; j=j+1) {

    temp = xP[0][1][j] - (xP[0][1][1] - xP[0][1][0]) / 4.0; // # in x direction
    ofW.write((char *) &temp, sizeof(real));
    
    temp = xP[0][1][j] + (xP[0][1][1] - xP[0][1][0]) / 4.0; // # in y direction
    ofW.write((char *) &temp, sizeof(real));

  }

  k = pointNumberMeshP[0][2]; 
 
  // store first row j=0, next second row j=1, ans so on
  for (j=0; j<= 2 * pointNumberMeshP[0][1]-1; j=j+1) {
    for (i=0; i<= 2 * pointNumberMeshP[0][0]-1; i=i+1) {
      //middle surface
      temp = wOutput[0][i][j][k]; // # in y direction
      ofW.write((char *) &temp, sizeof(real));
    }
  }
  */

  
  ofW.open( filenameW.c_str() ) ;

  ofW<< 2 * pointNumberMeshP[0][0] <<endl; // # in x direction
  ofW<< 2 * pointNumberMeshP[0][1] <<endl; // # in y direction
  ofW<< 2 * pointNumberMeshP[0][2] <<endl; // # in y direction

  //x coordinate
  for (i=0; i<=pointNumberMeshP[0][0]-1; i=i+1) {
    ofW<< xP[0][0][i] - (xP[0][0][1] - xP[0][0][0]) / 4.0 <<endl;
    ofW<< xP[0][0][i] + (xP[0][0][1] - xP[0][0][0]) / 4.0 <<endl;
  }

  //y coordinate
  for (j=0; j<=pointNumberMeshP[0][1]-1; j=j+1) {
    ofW<< xP[0][1][j] - (xP[0][1][1] - xP[0][1][0]) / 4.0 <<endl;
    ofW<< xP[0][1][j] + (xP[0][1][1] - xP[0][1][0]) / 4.0 <<endl;
  }

  //y coordinate
  for (k=0; k<=pointNumberMeshP[0][2]-1; k=k+1) {
    ofW<< xP[0][2][k] - (xP[0][2][1] - xP[0][2][0]) / 4.0 <<endl;
    ofW<< xP[0][2][k] + (xP[0][2][1] - xP[0][2][0]) / 4.0 <<endl;
  }

  //  k = pointNumberMeshP[0][2]; 
 
  // store first row j=0, next second row j=1, ans so on
  for (k=0; k<= 2 * pointNumberMeshP[0][2]-1; k=k+1) {
    for (j=0; j<= 2 * pointNumberMeshP[0][1]-1; j=j+1) {
      for (i=0; i<= 2 * pointNumberMeshP[0][0]-1; i=i+1) {
	//middle surface
	ofW<< wOutput[0][i][j][k] <<endl;
      }
    }
  }
    

  ofW.close();

  delete4dArrayOutput(wOutput, NumberOfMeshes, pointNumberMeshP);

}




void outputData::outputP(int tStep,
			 int NumberOfMeshes,
			 int cellNumberPerPatch,
			 int ** StartIndex, 
			 int ** pointNumberMeshP, 
			 real ***xP, 
			 real ****p){

  real ****pOutput;
  
  pOutput = allocate4dRealArrayOutput(NumberOfMeshes, pointNumberMeshP);

  // only need m=0
  m=0;
  for (k=0; k<=pointNumberMeshP[m][2]-1; k=k+1) {
    for (j=0; j<=pointNumberMeshP[m][1]-1; j=j+1) {
      for (i=0; i<=pointNumberMeshP[m][0]-1; i=i+1) {
	
	for (kCenter=2*k; kCenter <= 2*k + 1; kCenter++){	
	  for (jCenter=2*j; jCenter <= 2*j + 1; jCenter++){	
	    for (iCenter=2*i; iCenter <= 2*i + 1; iCenter++){	
	      pOutput[0][iCenter][jCenter][kCenter] = p[0][i][j][k];
	    }
	  }
	}

      }
    }
  }
  

  for (m=1; m<NumberOfMeshes; m++) {
    for (k=0; k<=pointNumberMeshP[m][2]-1; k=k+1) {
      for (j=0; j<=pointNumberMeshP[m][1]-1; j=j+1) {
	for (i=0; i<=pointNumberMeshP[m][0]-1; i=i+1) {

	  iCenter = 2 * (StartIndex[m][0] - 1) + i;
	  jCenter = 2 * (StartIndex[m][1] - 1) + j;
	  kCenter = 2 * (StartIndex[m][2] - 1) + k;

	  pOutput[0][iCenter][jCenter][kCenter] = p[m][i][j][k];

	}
      }
    }
  }


  filenameP = "results/p" + iToString(tStep) + ".dat";
  /*
  ofP.open( filenameP.c_str(), ios_base::out | ios_base::binary ) ;

  real temp;

  temp = 2 * pointNumberMeshP[0][0]; // # in x direction
  ofP.write((char *) &temp, sizeof(real));
  
  temp = 2 * pointNumberMeshP[0][1]; // # in y direction
  ofP.write((char *) &temp, sizeof(real));
  
  //x coordinate
  for (i=0; i<=pointNumberMeshP[0][0]-1; i=i+1) {

    temp = xP[0][0][i] - (xP[0][0][1] - xP[0][0][0]) / 4.0; // # in x direction
    ofP.write((char *) &temp, sizeof(real));
    
    temp = xP[0][0][i] + (xP[0][0][1] - xP[0][0][0]) / 4.0; // # in y direction
    ofP.write((char *) &temp, sizeof(real));

  }

  //y coordinate
  for (j=0; j<=pointNumberMeshP[0][1]-1; j=j+1) {

    temp = xP[0][1][j] - (xP[0][1][1] - xP[0][1][0]) / 4.0; // # in x direction
    ofP.write((char *) &temp, sizeof(real));
    
    temp = xP[0][1][j] + (xP[0][1][1] - xP[0][1][0]) / 4.0; // # in y direction
    ofP.write((char *) &temp, sizeof(real));

  }

  k = pointNumberMeshP[0][2]; 
 
  // store first row j=0, next second row j=1, ans so on
  for (j=0; j<= 2 * pointNumberMeshP[0][1]-1; j=j+1) {
    for (i=0; i<= 2 * pointNumberMeshP[0][0]-1; i=i+1) {
      //middle surface
      temp = pOutput[0][i][j][k]; // # in x direction
      ofP.write((char *) &temp, sizeof(real));
    }
  }
  */


  
  ofP.open( filenameP.c_str() ) ;
  
  ofP<< 2 * pointNumberMeshP[0][0] <<endl; // # in x direction
  ofP<< 2 * pointNumberMeshP[0][1] <<endl; // # in y direction
  ofP<< 2 * pointNumberMeshP[0][2] <<endl; // # in y direction

  //x coordinate
  for (i=0; i<=pointNumberMeshP[0][0]-1; i=i+1) {
    ofP<< xP[0][0][i] - (xP[0][0][1] - xP[0][0][0]) / 4.0 <<endl;
    ofP<< xP[0][0][i] + (xP[0][0][1] - xP[0][0][0]) / 4.0 <<endl;
  }

  //y coordinate
  for (j=0; j<=pointNumberMeshP[0][1]-1; j=j+1) {
    ofP<< xP[0][1][j] - (xP[0][1][1] - xP[0][1][0]) / 4.0 <<endl;
    ofP<< xP[0][1][j] + (xP[0][1][1] - xP[0][1][0]) / 4.0 <<endl;
  }

  //y coordinate
  for (k=0; k<=pointNumberMeshP[0][2]-1; k=k+1) {
    ofP<< xP[0][2][k] - (xP[0][2][1] - xP[0][2][0]) / 4.0 <<endl;
    ofP<< xP[0][2][k] + (xP[0][2][1] - xP[0][2][0]) / 4.0 <<endl;
  }


  //  k = pointNumberMeshP[0][2]; 
 
  // store first row j=0, next second row j=1, ans so on
  for (k=0; k<= 2 * pointNumberMeshP[0][2]-1; k=k+1) {
    for (j=0; j<= 2 * pointNumberMeshP[0][1]-1; j=j+1) {
      for (i=0; i<= 2 * pointNumberMeshP[0][0]-1; i=i+1) {
	//middle surface
	ofP<< pOutput[0][i][j][k] <<endl;
      }
    }
  }
 
  
  ofP.close();

  delete4dArrayOutput(pOutput, NumberOfMeshes, pointNumberMeshP);

}


string outputData::iToString(int k){
  // Converts an integer to a string
  // Requires <sstream> include file

  stringstream s;
  s <<  k;
  return s.str();
}


real **** outputData::allocate4dRealArrayOutput(int nMeshes, int **pointNumberMesh){
  real ****x = new real ***[nMeshes];

  // only need m=0
  m=0;
  x[m] = new real **[2 * pointNumberMesh[m][0]];
  for (i=0; i<2 * pointNumberMesh[m][0]; i++) {
    x[m][i] = new real*[2 * pointNumberMesh[m][1]];
    for (j=0; j<2 * pointNumberMesh[m][1]; j++) {
      x[m][i][j] = new real[2 * pointNumberMesh[m][2]];
    }
  }

  return x;
}

void outputData::delete4dArrayOutput(real ****x, int nMeshes, int **pointNumberMesh){

  // only need m=0
  m=0;
  for (i=0; i<2 * pointNumberMesh[m][0]; i++) {
    for (j=0; j<2 * pointNumberMesh[m][1]; j++) {
      delete [] x[m][i][j];
    }
    delete [] x[m][i];
  }
  delete [] x[m];
  
  delete [] x;
}

void outputData::coarseToCenter(real ix, // 0 for odd; 1 for even in x direction
				real iy, // 0 for odd; 1 for even in y direction
				real iz, // 0 for odd; 1 for even in z direction
				real ****u,
				real ****uOutput){

  uOutput[m][iCenter][jCenter][kCenter] = ( pow(3.0, fabs(ix) + fabs(iy) + fabs(iz))
				 * u[0][i][j][k]       //WSB
				 + pow(3.0, fabs(ix - 1) + fabs(iy) + fabs(iz))
				 * u[0][i+1][j][k]     //ESB
				 + pow(3.0, fabs(ix) + fabs(iy - 1) + fabs(iz))
				 * u[0][i][j+1][k]     //WNB
				 + pow(3.0, fabs(ix - 1) + fabs(iy - 1) + fabs(iz))
				 * u[0][i+1][j+1][k]   //ENB
				 + pow(3.0, fabs(ix) + fabs(iy) + fabs(iz - 1))
				 * u[0][i][j][k+1]     //WST
				 + pow(3.0, fabs(ix - 1) + fabs(iy) + fabs(iz - 1))
				 * u[0][i+1][j][k+1]   //EST
				 + pow(3.0, fabs(ix) + fabs(iy - 1) + fabs(iz - 1))
				 * u[0][i][j+1][k+1]   //WNT
				 + pow(3.0, fabs(ix - 1) + fabs(iy - 1) + fabs(iz - 1))
				 * u[0][i+1][j+1][k+1] //ENT
				 ) / 64.0;
}

outputData::~outputData(){
}
