#include "projectionMethod.h"


projectionMethod::projectionMethod(){
}

void projectionMethod::solve(int nPatch,
			     real t,
			     real dt,
			     real Re,
			     int cellNumberPerPatch, 
			     int ** StartIndex, 
			     int ** pointNumberMeshU, 
			     int ** pointNumberMeshV, 
			     int ** pointNumberMeshW, 
			     int ** pointNumberMeshP, 
			     int dim,
			     real ***xU, 
			     real ***xV, 
			     real ***xW, 
			     real ***xP, 
			     real *h,
			     real ****u,
			     real ****uIter,
			     int ****uCagePoint,
			     real ****v,
			     real ****vIter,
			     int ****vCagePoint,
			     real ****w,
			     real ****wIter,
			     int ****wCagePoint,
			     real ****p,
			     real ****uAux,
			     real ****vAux,
			     real ****wAux,
			     real ****fp, 
			     real ****exactP, 
			     int ****pUnknowns,
			     int ****pCagePoint,
			     PetscLinearSolver &pSolver,
			     int &zeroInitialGuess){

  uStar star;
  star.initialize(nPatch,
		  t,
		  dt,
		  Re,
		  cellNumberPerPatch, 
		  StartIndex, 
		  pointNumberMeshU, 
		  pointNumberMeshV, 
		  pointNumberMeshW, 
		  dim,
		  xU, 
		  xV, 
		  xW, 
		  h,
		  u,
		  uIter,
		  uCagePoint,
		  v,
		  vIter,
		  vCagePoint,
		  w,
		  wIter,
		  wCagePoint,
		  uAux,
		  vAux,
		  wAux);

  divUStar dObj;
  dObj.initialize(nPatch,
		  dt,
		  cellNumberPerPatch,
		  StartIndex,
		  fp,
		  pointNumberMeshP, 
		  h,
		  xP,
		  uAux,
		  vAux,
		  wAux);

  /*
  for (m=0; m<=nPatch; m++) {
    for (j=0; j<pointNumberMeshU[m][1]; j++) {
      for (i=0; i<pointNumberMeshU[m][0]; i++) {
	cout << uAux[m][i][j] <<" "; 
      }
      cout << endl;
    }
    cout<<"=============u=============="<<endl;
  }

  for (m=0; m<=nPatch; m++) {
    for (j=0; j<pointNumberMeshV[m][1]; j++) {
      for (i=0; i<pointNumberMeshV[m][0]; i++) {
	cout << vAux[m][i][j] <<" "; 
      }
      cout << endl;
    }
    cout<<"=============v=============="<<endl;
  }

  for (m=0; m<=nPatch; m++) {
    for (j=0; j<pointNumberMeshP[m][1]; j++) {
      for (i=0; i<pointNumberMeshP[m][0]; i++) {
	cout << fp[m][i][j]*pUnknowns[m][i][j] <<" "; 
      }
      cout << endl;
    }
    cout<<"==============fp============="<<endl;
  }
  */

  
  pressure press;
  press.initialize(nPatch,
		   cellNumberPerPatch,
		   StartIndex,
		   pointNumberMeshP,
		   dim,
		   xP,
		   h,
		   fp,
		   exactP,
		   pUnknowns,
		   p,
		   pCagePoint,
		   pSolver,
		   zeroInitialGuess);
  
  uNew uUpdate;
  uUpdate.initialize(nPatch,
		     t,
		     dt,
		     cellNumberPerPatch, 
		     StartIndex, 
		     pointNumberMeshU, 
		     pointNumberMeshV, 
		     pointNumberMeshW, 
		     pointNumberMeshP,
		     dim,
		     xU, 
		     xV, 
		     xW, 
		     h,
		     uIter,
		     uCagePoint,
		     vIter,
		     vCagePoint,
		     wIter,
		     wCagePoint,
		     uAux,
		     vAux,
		     wAux,
		     p);


  /*
  for (m=0; m<=nPatch; m++) {
    cout<<"=============p=============="<<endl;
    for (j=0; j<pointNumberMeshP[m][1]; j++) {
      for (i=0; i<pointNumberMeshP[m][0]; i++) {
	cout << p[m][i][j] <<" "; 
      }
      cout << endl;
    }
  }
  */

}




projectionMethod::~projectionMethod(){
}
