#include "vorticity.h"


vorticity::vorticity(){
}

void vorticity::calOmegaFromUVW(int numberOfPatches,
			       int ** pointNumberMeshOmegaX, 
			       int ** pointNumberMeshOmegaY, 
			       int ** pointNumberMeshOmegaZ, 
			       real *h,
			       real ****u,
			       real ****v,
			       real ****w,
			       real ****omegaX,
			       real ****omegaY,
			       real ****omegaZ){
  
  nPatch = numberOfPatches;

  ///////////////////////////////////////////
  //
  //vorticity in the coarse mesh
  //
  //////////////////////////////////////////

  for (k=0; k<pointNumberMeshOmegaZ[0][2]; k++) {
    for (j=0; j<pointNumberMeshOmegaZ[0][1]; j++) {
      for (i=0; i<pointNumberMeshOmegaZ[0][0]; i++) {
	omegaZ[0][i][j][k] = (v[0][i+1][j][k] - v[0][i][j][k]) / h[0]
	  - (u[0][i][j+1][k] - u[0][i][j][k]) / h[0]; 
      }
    }
  }

  for (k=0; k<pointNumberMeshOmegaX[0][2]; k++) {
    for (j=0; j<pointNumberMeshOmegaX[0][1]; j++) {
      for (i=0; i<pointNumberMeshOmegaX[0][0]; i++) {
	omegaX[0][i][j][k] = (w[0][i][j+1][k] - w[0][i][j][k]) / h[0]
	  - (v[0][i][j][k+1] - v[0][i][j][k]) / h[0]; 
      }
    }
  }

  for (k=0; k<pointNumberMeshOmegaY[0][2]; k++) {
    for (j=0; j<pointNumberMeshOmegaY[0][1]; j++) {
      for (i=0; i<pointNumberMeshOmegaY[0][0]; i++) {
	omegaY[0][i][j][k] = (u[0][i][j][k+1] - u[0][i][j][k]) / h[0]
	  - (w[0][i+1][j][k] - w[0][i][j][k]) / h[0]; 
      }
    }
  }


  ///////////////////////////////////////////
  //
  //vorticity in the patches
  //
  //////////////////////////////////////////

  for (m=1; m<=nPatch; m++) {
    for (k=0; k<pointNumberMeshOmegaZ[m][2]; k++) {
      for (j=0; j<pointNumberMeshOmegaZ[m][1]; j++) {
	for (i=0; i<pointNumberMeshOmegaZ[m][0]; i++) {
	  omegaZ[m][i][j][k] = (v[m][i+1][j+1][k] - v[m][i][j+1][k]) / h[m]
	    - (u[m][i+1][j+1][k] - u[m][i+1][j][k]) / h[m]; 
	}
      }
    }
  }

  for (m=1; m<=nPatch; m++) {
    for (k=0; k<pointNumberMeshOmegaX[m][2]; k++) {
      for (j=0; j<pointNumberMeshOmegaX[m][1]; j++) {
	for (i=0; i<pointNumberMeshOmegaX[m][0]; i++) {
	  omegaX[m][i][j][k] = (w[m][i][j+1][k+1] - w[m][i][j][k+1]) / h[m]
	    - (v[m][i][j+1][k+1] - v[m][i][j+1][k]) / h[m]; 
	}
      }
    }
  }

  for (m=1; m<=nPatch; m++) {
    for (k=0; k<pointNumberMeshOmegaY[m][2]; k++) {
      for (j=0; j<pointNumberMeshOmegaY[m][1]; j++) {
	for (i=0; i<pointNumberMeshOmegaY[m][0]; i++) {
	  omegaY[m][i][j][k] = (u[m][i+1][j][k+1] - u[m][i+1][j][k]) / h[m]
	    - (w[m][i+1][j][k+1] - w[m][i][j][k+1]) / h[m]; 
	}
      }
    }
  }


  
}


vorticity::~vorticity(){
}
